// Unit testing library functions

var original_caterwaul = caterwaul.deglobalize();

var log = function (message) {
  if (typeof console === 'undefined') print(message);
  else                                console.log(message);
};

var on_error = function (name, e) {
  log('Error at eq count ' + eq_count + ' in test ' + name + ': ' + (e.description || e));
  throw new Error(e);
};

var eq_count = 0;
var eq = function (x, y, message) {
  ++eq_count;
  if (x == y) return true;
  else        return on_error(current_test, (message ? message + ': ' : ' (eq ' + eq_count + ')') + '\n' + x + ' !== ' + y);
};

var current_test = null;
var test = function (name, f) {
  log('[unit] starting test ' + (current_test = name));

  try {
    eq_count  = 0;
    caterwaul = original_caterwaul.clone();
    f();

    eq_count  = 0;
    caterwaul = caterwaul.reinitialize(caterwaul);
    f();
  } catch (e) {
    on_error(name, e);
  }
};
// Generated by SDoc 
